/*
 * This file is placed in the public domain by Alan L. Cox <alc@cs.rice.edu>.
 */

#ifndef	_HPCC_H_
#define	_HPCC_H_

#include <sys/types.h>
#include <sys/time.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef __amd64__
#define	LONG_IS_64BITS
#endif

#define MPI_Wtime()	({						\
	struct timespec ts;						\
									\
	clock_gettime(CLOCK_REALTIME, &ts);				\
	(double)ts.tv_sec + (double)ts.tv_nsec / 1000000000.0;	 })

/* Define 64-bit types and corresponding format strings for printf() and constants */
#ifdef LONG_IS_64BITS
typedef unsigned long u64Int;
typedef long s64Int;
#define FSTR64 "%ld"
#define ZERO64B 0L
#else
typedef unsigned long long u64Int;
typedef long long s64Int;
#define FSTR64 "%lld"
#define ZERO64B 0LL
#endif

/* parameters of execution */
typedef struct {
  char outFname[256 + 1];
  size_t HPLMaxProcMem;
  s64Int RandomAccess_N;
} HPCC_Params;

extern int HPCC_RandomAccess(HPCC_Params *params, int doIO, double *GUPs, int *failure);

#define XMALLOC(t,s) ((t*)malloc(sizeof(t)*(s)))

#endif	/* !_HPCC_H_ */
